#include <iostream>
#include <vector>
#include <sstream>
#include <unistd.h>
using namespace std;
#include "kom.h"
#include "shaft.h"
#include "TomiTCP/str.h"

// pripojeni a zjisteni stavu
Kom::Kom(string addr, string port)
{
    conn.connect(addr, port);

    odesli("shafts");
    odesli("levels");
}

// odeslani zpravy serveru
void Kom::odesli(string m)
{
    printf("-> %s\n",m.c_str());
    fprintf(conn,"%s\r\n",m.c_str());
}

// zpracovavej data ze serveru
void Kom::zpracuj()
{
    string msg;

    while (input_timeout(conn.sock, 1000000) > 0) {
	if (!conn.getline(msg)) {
	    throw runtime_error("Server uzavrel spojeni");
	}

	wstrip(msg);
	cout << msg << endl;
	for (vector<Vytah>::iterator i = vytahy.begin(); i != vytahy.end(); i++)
	    i->zprava(msg);
	zprava(msg);
	for (vector<Vytah>::iterator i = vytahy.begin(); i != vytahy.end(); i++)
	    i->zkus_jet();
    }
}

// zpracovani jedne zpravy ze serveru
void Kom::zprava(string m)
{
    vector<string> par;
    stringstream sm(m);
    string s;

    // rozparseni na parametry
    while (sm >> s) {
	par.push_back(s);
    }

    if (! par.size())
	return;

    if (par[0] == "shafts" && par.size() > 1) {
	shafts = atol(par[1].c_str());
	vytahy.clear();
	for (int i = 0; i < shafts; i++) {
	    vytahy.push_back(Vytah(this,i));
	}
	return;
    }
    
    if (par[0] == "levels" && par.size() > 1) {
	levels = atol(par[1].c_str());
	return;
    }
    
    if (par[0] == "levelbuttonup" && par.size() > 1) {
	levelbuttonup(atol(par[1].c_str()));
    }
    
    if (par[0] == "levelbuttondn" && par.size() > 1) {
	levelbuttondown(atol(par[1].c_str()));
    }
    
    if (par[0] == "opened" && par.size() > 1) {
	opened(atol(par[1].c_str()));
    }

    if (par[0] == "closed" && par.size() > 1) {
	closed(atol(par[1].c_str()));
    }
    
    if (par[0] == "blocked" && par.size() > 1) {
	blocked(atol(par[1].c_str()));
    }
    
    if (par[0] == "level" && par.size() > 2) {
	level(atol(par[1].c_str()),atol(par[2].c_str()));
    }

    if (par[0] == "cabinbutton" && par.size() > 2) {
	cabinbutton(atol(par[1].c_str()),atol(par[2].c_str()));
    }
}

void Kom::levelbuttonup(int l)
{
    odesli("indiupon "+inttostr(l));
    if (podlazi(l))
	return;
    Vytah *v = volny();
    if (!v)
	v = nejblizsi(l);
    if (v)
	v->jed(l);
}

void Kom::levelbuttondown(int l)
{
    odesli("indidnon "+inttostr(l));
    if (podlazi(l))
	return;
    Vytah *v = volny();
    if (!v)
	v = nejblizsi(l);
    if (v)
	v->jed(l);
}

void Kom::level(int s, int l)
{
    vytahy[s].level(l);
}

void Kom::cabinbutton(int s, int l)
{
    odesli("indion "+inttostr(s)+" "+inttostr(l));
    vytahy[s].jed(l);
}

void Kom::opened(int s)
{
    vytahy[s].opened();
}

void Kom::closed(int s)
{
    vytahy[s].closed();
}

// dvere blokovany, pockame a zkusime znova
void Kom::blocked(int s)
{
    usleep(500000);
    odesli("close "+inttostr(s));
}

// jsem na podlazi l, ostatni vytahy tam jezdit nemusi...
void Kom::podlazi_ok(int l)
{
    for (vector<Vytah>::iterator j = vytahy.begin(); j != vytahy.end(); j++) {
	for (vector<int>::iterator i = j->patra.begin(); i != j->patra.end(); i++) {
	    if (*i == l) {
		j->patra.erase(i);
		break;
	    }
	}
    }
}

// jede uz neco na podlazi l?
bool Kom::podlazi(int l)
{
    for (vector<Vytah>::iterator j = vytahy.begin(); j != vytahy.end(); j++) {
	for (vector<int>::iterator i = j->patra.begin(); i != j->patra.end(); i++) {
	    if (*i == l) {
		return 1;
	    }
	}
    }

    return 0;
}

// najdi nejblizsi vytah
Vytah * Kom::nejblizsi(int l)
{
    int patro = 0xffffff;
    vector<Vytah>::iterator vytah;
    for (vector<Vytah>::iterator i = vytahy.begin(); i != vytahy.end(); i++) {
	if (abs(l - i->lev()) < abs(l - patro)) {
	    patro = i->lev();
	    vytah = i;
	}
    }
    if (patro == 0xffffff) {
	return 0;
    }

    return &(*vytah);
}

// najdi volny vytah (volny k pohybu)
Vytah * Kom::volny()
{
    for (vector<Vytah>::iterator i = vytahy.begin(); i != vytahy.end(); i++) {
	if (! i->busy())
	    return &(*i);
    }

    return 0;
}
