#include <iostream>
using namespace std;
#include "TomiTCP/str.h"
#include "shaft.h"
#include "kom.h"

// nastaveni vytahu na zakladni pozici
Vytah::Vytah(Kom* kom, int shaft)
{
    k = kom;
    s = shaft;
    l = 0;
    opening = 0;
    
    k->odesli("close "+inttostr(s));
    waiting.push_back(Wait("closed "+inttostr(s),"floor "+inttostr(s)+" 0"));
    k->odesli("shaftinfo "+inttostr(s)+ " 0");
}

void Vytah::level(int lev)
{
    l = lev;
    
    k->podlazi_ok(l);

    if (!open && !opening) {
	k->odesli("open "+inttostr(s));
	opening = 1;
	waiting.push_back(Wait("opened "+inttostr(s),""));
    }
    k->odesli("shaftinfo "+inttostr(s)+" "+inttostr(lev));
    k->odesli("indiupoff "+inttostr(lev));
    k->odesli("indidnoff "+inttostr(lev));
    k->odesli("indioff "+inttostr(s)+" "+inttostr(lev));
}

// pokyn k jizde - ulozeni do fronty pater
void Vytah::jed(int lev)
{
    if (lev == l) {
	k->odesli("indiupoff "+inttostr(lev));
	k->odesli("indidnoff "+inttostr(lev));
	k->odesli("indioff "+inttostr(s)+" "+inttostr(lev));

	if (!open && !opening) {
	    k->odesli("open "+inttostr(s));
	    opening = 1;
	    waiting.push_back(Wait("opened "+inttostr(s),""));
	}
	return;
    }

    for (vector<int>::iterator i = patra.begin(); i != patra.end(); i++)
	if (lev == *i)
	    return;

    patra.push_back(lev);

    zkus_jet();
}

inline int abs(int a) { return (a<0)?-a:a; }

// pokud nejsme busy, najdeme nejblizsi patro a jedeme tam
void Vytah::zkus_jet()
{
    if (busy())
	return;
    
    // nalezeni nejblizsiho patra
    int kam = 0xffffff;
    vector<int>::iterator kam_i;
    for (vector<int>::iterator i = patra.begin(); i != patra.end(); i++) {
	if (abs(l - *i) < abs(l - kam)) {
	    kam = *i;
	    kam_i = i;
	}
    }
    if (kam == 0xffffff) {
	return;
    }

    if (open) {
	k->odesli("close "+inttostr(s));
	waiting.push_back(Wait("closed "+inttostr(s),"floor "+inttostr(s)+" "+inttostr(kam)));
	waiting.push_back(Wait("level "+inttostr(s)+" "+inttostr(kam),""));
    } else {
	k->odesli("floor "+inttostr(s)+" "+inttostr(kam));
	waiting.push_back(Wait("level "+inttostr(s)+" "+inttostr(kam),""));
    }
}

// zprava od serveru, zkontrolujeme zda-li je v cekaci fronte atd.
void Vytah::zprava(string m)
{
    for (vector<Wait>::iterator i = waiting.begin(); i != waiting.end(); i++) {
	if (m == i->msg) {
	    if (i->next.length())
		k->odesli(i->next);
	    waiting.erase(i);
	    return;
	}
    }
}

// jsme busy? (mame neco v cekaci fronte?)
bool Vytah::busy()
{
    return waiting.size() > 0;
}

void Vytah::opened()
{
    open = 1;
    opening = 0;
}

void Vytah::closed()
{
    open = 0;
}
